#include "Inkey.ch"
PROCEDURE MAIN(cAuto,cSElect,cExt,cOutput)
LOCAL LogsPath := "..\LOGS" 
LOCAL nKey := 0 ,I  
LOCAL aStructure := { ;
	      { "TABLE_NAME", "C",  20, 0 }, ;
	      { "FIELD_NAME", "C", 10, 0 }, ;
	      { "FIELD_LEN", "N", 2, 0 }, ;
	      { "FIELD_DEC", "N",  2, 0 }, ;
	      { "RECID", "N", 10, 0 }, ;
	      { "VALUE", "N", 19, 7 }, ;
	      { "CVALUE", "C", 30, 0 }, ;
	      { "UPDATED", "L", 1, 0 }}

SETCANCEL(.F.)
SET EXCLUSIVE OFF
SET ESCAPE ON      
CLEAR
SET CONFIRM ON
SET STATUS OFF
SET EXACT OFF
SET SAFETY OFF
SET TALK OFFG
SET WRAP ON
SET BELL OFF
SET DELETE ON
SETCURSOR(3)
SET DATE FORMAT "dd/mm/yy"
SET FIXED OFF

IF EMPTY(cAuto)
	cAuto = "0"
ENDIF

IF EMPTY(cSElect)
	cSElect = "*.DBF"
ELSE
	cSElect = UPPER(cSElect)
ENDIF

IF EMPTY(cExt)
	cExt = "DBI"
ELSE
	cExt = UPPER(cExt)
ENDIF

IF EMPTY(cOutput)
	cOutput = "CRD_"+DTOS(Date())+StrTran(Time(),":","")+".LOG"
ELSE
	cOutput = UPPER(cOutput)+".LOG"
ENDIF

IF FExists(LogsPath,"D")
	cOutput = LogsPath+"\"+cOutput
ENDIF

PRIVATE dbCount := ADIR(cSElect)
PRIVATE aFiles[dbCount]
ADIR(cSElect,aFiles)
ASORT(aFiles)

? "Table scope is : ["+cSElect+"]"
? "NTX Extension is : ["+cExt+"]"
IF cAuto == "1"
   nKey = 89
   //? "Do you want to continue...(Y/N)?: Y"
ELSE
DO WHILE nKey <> K_ESC 
   ? "Do you want to continue...(Y/N)?: "
   nKey := Inkey(0) 
   IF nKey =  89 .or. nKey =  121
   	 EXIT 
   ELSEIF nKey =  78 .or. nKey =  110
     Quit
   ENDIF
ENDDO
ENDIF
IF nKey<>K_ESC
SET PRINTER TO &cOutput
SET DEVICE TO PRINTER
SET PRINTER ON
DbCreate( "CORRDEC.DBF", aStructure, "DBFNTX" )
nCorrdec = SELECT()

IF NET_USE("CORRDEC.DBF",.T.,5)
	x = ADir(Alias()+"?."+cExt)
	aFileName = array(x)
	ADir(Alias()+"?."+cExt,aFileName)
	IF x > 0
   	 SetNtxFile(aFileName)
	ENDIF	
ELSE
 ?? "<<<<<<<<<<<<<<<<<<<< ERROR CAN'T OPEN THIS TABLE <<<<<<<<<<<<<<<<<<<<" 
ENDIF


FOR I = 1 TO dbCount
 IF UPPER(aFiles[I]) <> "CORRDEC.DBF"
    CORRDEC(aFiles[I],cExt)
 ENDIF
NEXT I

//CLOSE ALL

//CORRUP(cExt)

SET DEVICE TO SCREEN
SET PRINTER OFF
SET PRINTER TO
IF cAuto == "1"
	 ? "CORRDEC Job is completed!"
ELSE
	 WAIT "CORRDEC Job is completed!"
ENDIF
ENDIF
RETURN

***********************
PROCEDURE CORRDEC(dbName,cExt)
***********************
LOCAL aStruct,aFileName,i,nSelect
? dbName, "......"
SELECT 0
IF NET_USE(dbName,.T.,5)
	x = ADir(Alias()+"?."+cExt)
	aFileName = array(x)
	ADir(Alias()+"?."+cExt,aFileName)
	IF x > 0
   	 SetNtxFile(aFileName)
	ENDIF      
	
ELSE
 ?? "<<<<<<<<<<<<<<<<<<<< ERROR CAN'T OPEN THIS TABLE <<<<<<<<<<<<<<<<<<<<" 
ENDIF
nSelect = Select()
IF USED()
nFieldCount  := FCOUNT()
aStruct := DBSTRUCT()
ASORT(aStruct,,,{ |x,y| x[1] < y[1] })
DO WHILE !EOF()
	nLoop = 0
	FOR K = 1 TO nFieldCount 
			IF aStruct[K,2] = "N"
			   cLastName = aStruct[K,1]
			   nRecNo = RecNo()
			    IF &cLastName <> ROUND(&cLastName,aStruct[K,4])
			    	// Strange Problem -> &cLastName <> ROUND(&cLastName,aStruct[K,4]), Why?? :(
			    	  nValue = &cLastName 
							IF nLoop == 0
							   ? "RecNo", ALLTRIM(STR(nRecNo,10))
									 IF REC_LOCK(10)
									 ELSE
									      ??  "Lock Error!"
									      EXIT
									 ENDIF
			    	     nLoop++
							ENDIF
							   SELECT(nCorrdec)
						      IF ADDREC(5)
										   REPLACE TABLE_NAME WITH dbName,;
										           FIELD_NAME WITH cLastName,;
										           FIELD_LEN WITH aStruct[K,3],;
										           FIELD_DEC WITH aStruct[K,4],;
										           RECID WITH nRecNo,;
										           VALUE WITH ROUND(nValue,aStruct[K,4]),;
										           CVALUE WITH STR(nValue,aStruct[K,3],aStruct[K,4])
										   COMMIT
										   UNLOCK
									ENDIF

							    
   	            ?? "|",ALLTRIM(cLastName)+"("+ALLTRIM(STR(nValue,aStruct[K,3],aStruct[K,4]))+")", ALLTRIM(STR(nValue- ROUND(nValue,aStruct[K,4]),30,20))
   	            	//********* Strange Problem: STR(nValue- ROUND(nValue,aStruct[K,4]),40,30) <> 0 ???? *********//

   	            SELECT(nSelect)

							 IF REC_LOCK(10)
   	            	REPLACE &cLastName WITH ROUND(nValue,aStruct[K,4]) // I want to fix it, But fail.... :(
   	            	?? "..Done!"
   	            	
						    	COMMIT
							  	UNLOCK
							 ELSE
							    ?  "Lock Error!",dbName,nRecNo
							    EXIT
							 ENDIF    

   	            //x = nValue - ROUND(nValue,aStruct[K,4])
   	            //?? "|",x
   	            //REPLACE &cLastName WITH &cLastName+0.0001
   	            //REPLACE &cLastName WITH &cLastName-0.0001
						    //COMMIT						    
						    //GO X
   	            //REPLACE &cLastName WITH ROUND(&cLastName,aStruct[K,3],aStruct[K,4]-1)+0.00000000001
						    //COMMIT
							  //UNLOCK
   	             //&cLastName With &cLastName-1
   	             //REPLACE &cLastName WITH Round(&cLastName,aStruct[K,4])+1

   	             
					ENDIF
			ENDIF
	NEXT K
	IF nLoop > 0
    COMMIT
	  UNLOCK
  ENDIF
  SKIP
ENDDO
?
SELECT(nSelect)
USE

ENDIF
RETURN

***********************
FUNCTION NET_USE
***********************
PARAMETERS file,ex_use,wait
PRIVATE forever
forever = (wait = 0)
DO WHILE (forever .OR. wait > 0)
IF ex_use
USE &file EXCLUSIVE
ELSE
USE &file
ENDIF
IF .NOT. NETERR()
RETURN (.T.)
ENDIF
INKEY(1)
wait = wait - 1
ENDDO
RETURN (.F.)

*---------------------------------*
FUNCTION SetNtxFile( cIndexList )
*---------------------------------*
LOCAL nLen := LEN(cIndexList),I,cNtxName
IF OrdNumber()>0
   ordListClear()
ENDIF
IF nLen > 0
	?? "|"
   FOR I = 1 TO nLen
       cNtxName = cIndexList[I]
       IF FILE(cNtxName)
          ordListAdd(cNtxName)
          ?? cNtxName+"|"  
       ELSE
          ? "Index file ["+cIndexList[I]+"] Not Exist!"
          IF I = 1 
             RETURN .F.
          ENDIF
       ENDIF
   ENDFOR
ENDIF
RETURN .T.

* REC_LOCK function
FUNCTION REC_LOCK
PARAMETERS wait
PRIVATE forever
IF RLOCK()
RETURN (.T.)
ENDIF
forever = (wait = 0)
DO WHILE (FOREVER .OR. wait > 0)
IF RLOCK()
RETURN (.T.)
ENDIF
INKEY(1)
wait = wait - 1
ENDDO
RETURN (.F.)

*---------------------*
FUNCTION ADDREC (  nWait )
*---------------------*
LOCAL forever, lOK := .T.
APPEND BLANK
IF NETERR()
	lOK := .F.
	forever = (nWait = 0)
	DO WHILE (FOREVER .OR. nWait > 0)
	APPEND BLANK
	IF !NETERR()
		 lOK := .T.
		 EXIT
	ENDIF
	**INKEY(1)
	nWait = nWait - 1
	ENDDO
ENDIF
IF lOK
		IF FieldPos("CREATEDATE")>0
		   REPLACE CREATEDATE WITH DATE()
		ENDIF
		IF FieldPos("CREATEUSER")>0
		   REPLACE CREATEUSER WITH ZZUSER
		ENDIF
ENDIF
RETURN lOK



***********************
PROCEDURE CORRUP(cExt)
***********************
LOCAL aStruct,aFileName,i,nSelect,cLast_dbName := "xxxxxxxxxxxx", nTarget

SELECT 0
IF NET_USE("CORRDEC.DBF",.T.,5)
	x = ADir(Alias()+"?."+cExt)
	aFileName = array(x)
	ADir(Alias()+"?."+cExt,aFileName)
	IF x > 0
   	 SetNtxFile(aFileName)
	ENDIF	
ELSE
 ?? "<<<<<<<<<<<<<<<<<<<< ERROR CAN'T OPEN THIS TABLE <<<<<<<<<<<<<<<<<<<<" 
ENDIF

DO WHILE !EOF()

cdbName =  ALLTRIM(TABLE_NAME)
cLastName = ALLTRIM(FIELD_NAME)
nRecNo = RECID
nDec = FIELD_DEC
nValue = VAL(cVALUE) //Round(VALUE,nDec)
 

IF cdbName<>cLast_dbName
		SELECT 0
		nTarget = SELECT()
		IF NET_USE(cdbName,.T.,5)
			x = ADir(Alias()+"?."+cExt)
			aFileName = array(x)
			ADir(Alias()+"?."+cExt,aFileName)
			IF x > 0
		   	 SetNtxFile(aFileName)
			ENDIF	
		ELSE
		 ?? "<<<<<<<<<<<<<<<<<<<< ERROR CAN'T OPEN THIS TABLE <<<<<<<<<<<<<<<<<<<<-----------:"+cdbName 
		ENDIF
		cLast_dbName = ALLTRIM(cdbName)
ENDIF

    SELECT(nTarget)
    DbGoto(nRecNo)
		
		? "RecNo", nRecNo
		 IF REC_LOCK(10)
//		 	  REPLACE &cLastName WITH  nValue
		 	  COMMIT
		 	  UNLOCK
		 ELSE
		    ??  "Lock Error!"
		    EXIT
		 ENDIF    	


		SELECT CORRDEC
		 IF REC_LOCK(10)
		 	  REPLACE UPDATED WITH .T.
		 	  COMMIT
		 	  UNLOCK
		 ELSE
		    ??  "Lock Error!"
		    EXIT
		 ENDIF    

SKIP
ENDDO
RETURN